import java.rmi.Naming;
import java.rmi.registry.LocateRegistry;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import implementacoes.CandidatoImpl;
import implementacoes.VotacaoImpl;
import interfaces.ApuracaoInterface;
import interfaces.VotacaoInterface;


public class ServidorVotacao {
	
	static List<CandidatoImpl> candidatos;
	static VotacaoInterface votacaoImpl;
	static int porta_servidor_votacao = 8898;
	static int porta_servidor_apuracao = 8899;
	static List<Integer> votos = new ArrayList<>();
    
	public static void main(String[] args) {
        try {
            System.out.println("Registrando o objeto no RMIRegistry...");
			
            LocateRegistry.createRegistry(porta_servidor_votacao);
			
            ApuracaoInterface apuracao = (ApuracaoInterface) Naming.lookup("//localhost:" + porta_servidor_apuracao + "/server");
            
			// Lista de Candidatos
			candidatos = new ArrayList<>();
			candidatos.add(new CandidatoImpl(1, "1 Luiz Picolo"));
			candidatos.add(new CandidatoImpl(2, "2 Luiz Picolo"));
			candidatos.add(new CandidatoImpl(3, "3 Luiz Picolo"));
			candidatos.add(new CandidatoImpl(4, "4 Luiz Picolo"));
			candidatos.add(new CandidatoImpl(5, "5 Luiz Picolo"));
			candidatos.add(new CandidatoImpl(6, "6 Luiz Picolo"));
			candidatos.add(new CandidatoImpl(7, "7 Luiz Picolo"));
			
			votacaoImpl = new VotacaoImpl(candidatos);
			
			Naming.rebind("//localhost:" + porta_servidor_votacao + "/server", votacaoImpl);
			
			System.out.println("Servidor de votação. Aguardando Clientes na porta " + porta_servidor_votacao + "!");
			
			while (true) {
				System.out.println("Aperte Enter para ver a apuração");
				Scanner entrada = new Scanner(System.in);
				entrada.nextLine();
				
				votos.clear();
				
				votacaoImpl.getVotos().forEach(x -> {
					votos.add(x.getCandidato().getNumero());
				});
				
				votacaoImpl.mostrar_apuracao(apuracao.calcularVotos(votos));
			}
        } catch (Exception e) {
            e.printStackTrace();
        }
    } 
}